Day 8: Resonant Collinearity
Megathread guidelines
- Keep top level comments as only solutions, if you want to say something other than a solution put it in a new post. (replies to comments can be whatever)
- You can send code in code blocks by using three backticks, the code, and then three backticks or use something such as https://topaz.github.io/paste/ if you prefer sending it through a URL
FAQ
- What is this?: Here is a post with a large amount of details: https://programming.dev/post/6637268
- Where do I participate?: https://adventofcode.com/
- Is there a leaderboard for the community?: We have a programming.dev leaderboard with the info on how to join in this post: https://programming.dev/post/6631465
Uiua
Adapting the part one solution for part two took me longer than part one did today, but I didn’t want to change much anymore.
I even got scolded by the interpreter to split the evaluating line onto multiple ones because it got too long.
Can’t say it’s pretty but it does it’s job ^^’Run with example input here
PartOne ← ( &rs ∞ &fo "input-8.txt" ⟜(▽¬∈".\n".◴) ⊜∘≠@\n. :¤⟜(:¤-1△) ≡(□⊚⌕) ◴/◇⊂⍚(≡(-:⟜-°⊟)⧅≠2) ⧻▽¬:⊙(/+⍉+)⟜⊓><,0 ) PartTwo ← ( &rs ∞ &fo "input-8.txt" ⟜(▽¬∈".\n".◴⟜¤ ▽:⟜≡(>1⧻⊚⌕) ) ⊜∘≠@\n. :¤⟜(:¤-1△) ≡(□⊚⌕) ⊸⍚( ⧅≠2⊙¤ ≡(:¤⟜-°⊟ ⍢(⊙⊂⟜-⊙⊸⊢ | ⋅(=0/++⊓><,0⊢)) □⊙◌◌ ) ) ◴/◇⊂/◇⊂ ⧻▽¬:⊙(/+⍉+)⟜⊓><,0 ) &p "Day 8:" &pf "Part 1: " &p PartOne &pf "Part 2: " &p PartTwo
Rust
For the first time, I can post my solution, because I actually solved it on the day :D Probably not the cleanest or optimal solution, but it does solve the problem.
Very long, looking forward to someone solving it in 5 lines of unicode :D
#[cfg(test)] mod tests { fn get_frequences(input: &str) -> Vec<char> { let mut freq = vec![]; for char in input.chars() { if char == '.' { continue; } if !freq.contains(&char) { freq.push(char); } } freq } fn find_antennas(board: &Vec<Vec<char>>, freq: char) -> Vec<(isize, isize)> { let mut antennas = vec![]; for (i, line) in board.iter().enumerate() { for (j, char) in line.iter().enumerate() { if *char == freq { antennas.push((i as isize, j as isize)); } } } antennas } fn calc_antinodes(first: &(isize, isize), second: &(isize, isize)) -> Vec<(isize, isize)> { let deltax = second.0 - first.0; let deltay = second.1 - first.1; if deltax == 0 && deltay == 0 { return vec![]; } vec![ (first.0 - deltax, first.1 - deltay), (second.0 + deltax, second.1 + deltay), ] } #[test] fn test_calc_antinodes() { let expected = vec![(0, -1), (0, 2)]; let actual = calc_antinodes(&(0, 0), &(0, 1)); for i in &expected { assert!(actual.contains(i)); } let actual = calc_antinodes(&(0, 1), &(0, 0)); for i in &expected { assert!(actual.contains(i)); } } fn calc_all_antinodes(board: &Vec<Vec<char>>, freq: char) -> Vec<(isize, isize)> { let antennas = find_antennas(&board, freq); let mut antinodes = vec![]; for (i, first) in antennas.iter().enumerate() { for second in antennas[i..].iter() { antinodes.extend(calc_antinodes(first, second)); } } antinodes } fn prune_nodes( nodes: &Vec<(isize, isize)>, height: isize, width: isize, ) -> Vec<(isize, isize)> { let mut pruned = vec![]; for node in nodes { if pruned.contains(node) { continue; } if node.0 < 0 || node.0 >= height { continue; } if node.1 < 0 || node.1 >= width { continue; } pruned.push(node.clone()); } pruned } fn print_board(board: &Vec<Vec<char>>, pruned: &Vec<(isize, isize)>) { for (i, line) in board.iter().enumerate() { for (j, char) in line.iter().enumerate() { if pruned.contains(&(i as isize, j as isize)) { print!("#"); } else { print!("{char}"); } } println!(); } } #[test] fn day8_part1_test() { let input: String = std::fs::read_to_string("src/input/day_8.txt").unwrap(); let frequencies = get_frequences(&input); let board = input .trim() .split('\n') .map(|line| line.chars().collect::<Vec<char>>()) .collect::<Vec<Vec<char>>>(); let mut all_nodes = vec![]; for freq in frequencies { let nodes = calc_all_antinodes(&board, freq); all_nodes.extend(nodes); } let height = board.len() as isize; let width = board[0].len() as isize; let pruned = prune_nodes(&all_nodes, height, width); println!("{:?}", pruned); print_board(&board, &pruned); println!("{}", pruned.len()); // 14 in test } fn calc_antinodes2(first: &(isize, isize), second: &(isize, isize)) -> Vec<(isize, isize)> { let deltax = second.0 - first.0; let deltay = second.1 - first.1; if deltax == 0 && deltay == 0 { return vec![]; } let mut nodes = vec![]; for n in 0..50 { nodes.push((first.0 - deltax * n, first.1 - deltay * n)); nodes.push((second.0 + deltax * n, second.1 + deltay * n)); } nodes } fn calc_all_antinodes2(board: &Vec<Vec<char>>, freq: char) -> Vec<(isize, isize)> { let antennas = find_antennas(&board, freq); let mut antinodes = vec![]; for (i, first) in antennas.iter().enumerate() { for second in antennas[i..].iter() { antinodes.extend(calc_antinodes2(first, second)); } } antinodes } #[test] fn day8_part2_test() { let input: String = std::fs::read_to_string("src/input/day_8.txt").unwrap(); let frequencies = get_frequences(&input); let board = input .trim() .split('\n') .map(|line| line.chars().collect::<Vec<char>>()) .collect::<Vec<Vec<char>>>(); let mut all_nodes = vec![]; for freq in frequencies { let nodes = calc_all_antinodes2(&board, freq); all_nodes.extend(nodes); } let height = board.len() as isize; let width = board[0].len() as isize; let pruned = prune_nodes(&all_nodes, height, width); println!("{:?}", pruned); print_board(&board, &pruned); println!("{}", pruned.len()); } }
Any solution that solves the problem is a good solution :D
Lisp
Could probably just write points right to the results instead of to an intermediate list, but it runs instantly, so my motivation to do so was low.
Code
(defun p1-process-line (line) (to-symbols line 'advt2024-d8)) (defun count-results (results) (loop for i from 0 below (array-total-size results) count (row-major-aref results i))) (defun place-annode (pos results) (let ((x (first pos)) (y (second pos))) (when (in-map results x y) (setf (aref results y x) t)))) (defun create-annodes-p1 (x1 y1 x2 y2) (let ((delta-x (- x2 x1)) (delta-y (- y2 y1))) (list (list (- x1 delta-x) (- y1 delta-y)) (list (+ x2 delta-x) (+ y2 delta-y))))) (defun place-annodes (positions results create-annodes) (when positions (loop with a = (car positions) with x1 = (first a) with y1 = (second a) for b in (cdr positions) for ans = (funcall create-annodes x1 y1 (first b) (second b)) do (dolist (a ans) (place-annode a results))) (place-annodes (cdr positions) results create-annodes))) (defun place-all-annodes (xmits map &optional (create-annodes #'create-annodes-p1)) (let ((results (make-array (array-dimensions map) :element-type 'boolean :initial-element nil))) (loop for k being the hash-key of xmits do (place-annodes (gethash k xmits) results create-annodes)) results)) (defun find-transmitters (map) "look throught the map and record where the transmitters are in a hash map" (let ((h (make-hash-table))) (destructuring-bind (rows cols) (array-dimensions map) (loop for j from 0 below rows do (loop for i from 0 below cols for v = (aref map j i) unless (eql v '|.|) do (push (list i j) (gethash v h)) ))) h)) (defun run-p1 (file) (let* ((map (list-to-2d-array (read-file file #'p1-process-line)))) (count-results (place-all-annodes (find-transmitters map) map)) )) (defun create-annodes-2 (x1 y1 x2 y2 map) (destructuring-bind (rows cols) (array-dimensions map) (let* ((m (/ (- y2 y1) (- x2 x1) )) (b (- y2 (* m x2)))) (loop for x from 0 below cols for y = (+ b (* x m)) for r = (nth-value 1 (floor y)) when (and (= r 0) (>= y 0) (< y rows)) collect (list x y))))) (defun run-p2 (file) (let* ((map (list-to-2d-array (read-file file #'p1-process-line)))) (count-results (place-all-annodes (find-transmitters map) map (lambda (x1 y1 x2 y2) (create-annodes-2 x1 y1 x2 y2 map))))))
Haskell
I overslept 26 minutes (AoC starts at 06:00 here) which upsets me more than it should.
I thought this one was going to be hard on performance or memory but it was surprisingly easy.import Control.Arrow hiding (first, second) import Data.Bifunctor import Data.Array.Unboxed (UArray) import qualified Data.List as List import qualified Data.Set as Set import qualified Data.Array.Unboxed as Array parse :: String -> UArray (Int, Int) Char parse s = Array.listArray ((1, 1), (n, m)) . filter (/= '\n') $ s :: UArray (Int, Int) Char where n = takeWhile (/= '\n') >>> length $ s m = List.filter (== '\n') >>> length >>> pred $ s groupSnd:: Eq b => (a, b) -> (a', b) -> Bool groupSnd = curry (uncurry (==) <<< snd *** snd) cartesianProduct xs ys = [(x, y) | x <- xs, y <- ys] calculateAntitone ((y1, x1), (y2, x2)) = (y1 + dy, x1 + dx) where dy = y1 - y2 dx = x1 - x2 antennaCombinations = Array.assocs >>> List.filter (snd >>> (/= '.')) >>> List.sortOn snd >>> List.groupBy groupSnd >>> map (map fst) >>> map (\ xs -> cartesianProduct xs xs) >>> map (filter (uncurry (/=))) part1 a = antennaCombinations >>> List.concatMap (map calculateAntitone) >>> List.filter (Array.inRange (Array.bounds a)) >>> Set.fromList >>> Set.size $ a calculateAntitones ((y1, x1), (y2, x2)) = iterate (bimap (+dy) (+dx)) (y1, x1) where dy = y1 - y2 dx = x1 - x2 part2 a = antennaCombinations >>> List.map (map calculateAntitones) >>> List.concatMap (List.concatMap (takeWhile (Array.inRange (Array.bounds a)))) >>> Set.fromList >>> Set.size $ a main = getContents >>= print . (part1 &&& part2) . parse
D’oh. Computing antinodes in a single direction and permuting pairs is a much neater approach that what I did!
Haskell
Not a very pretty solution today, I’m afraid.
import Control.Arrow import Control.Monad import Data.Biapplicative import Data.Ix import Data.Map (Map) import Data.Map qualified as Map import Data.Set qualified as Set type Coords = (Int, Int) readInput :: String -> Map Coords Char readInput s = Map.fromAscList [ ((i, j), c) | (i, l) <- zip [0 ..] (lines s), (j, c) <- zip [0 ..] l ] (.+.), (.-.) :: Coords -> Coords -> Coords (.+.) = join biliftA2 (+) (.-.) = join biliftA2 (-) part1, part2 :: (Coords -> Bool) -> (Coords, Coords) -> [Coords] part1 valid (p1, p2) = let s = p2 .-. p1 in filter valid [p1 .-. s, p2 .+. s] part2 valid (p1, p2) = let (si, sj) = p2 .-. p1 d = gcd si sj s = (si `div` d, sj `div` d) in takeWhile valid (iterate (.+. s) p1) ++ takeWhile valid (drop 1 $ iterate (.-. s) p2) pairs (x : xs) = map (x,) xs ++ pairs xs pairs _ = [] main = do input <- readInput <$> readFile "input08" let antennas = Map.filter (/= '.') input antennaGroups = Map.foldrWithKey (\p c m -> Map.insertWith (++) c [p] m) Map.empty antennas valid = inRange . (Set.findMin &&& Set.findMax) $ Map.keysSet input antiNodes model = Set.fromList . concatMap (concatMap (model valid) . pairs) $ antennaGroups print . Set.size $ antiNodes part1 print . Set.size $ antiNodes part2
Whaaat? It is possible to declare mutliple signatures on one line? 🤯
Does that function (.+.
) add tuples/coordinates?Yup, that’s right! The function monad is a bit of a mind-bender, but
(join f) x == f x x
is a useful thing to remember.This is so cool, it’s going to replace the lambda in my function pipeline for calculating pairs.
BTW, for more in-depth vector stuff I usually use the Linear package.
C#
public class Day08 : Solver { private ImmutableArray<string> data; private int width, height; public void Presolve(string input) { data = input.Trim().Split("\n").ToImmutableArray(); width = data[0].Length; height = data.Length; } public string SolveFirst() { Dictionary<char, List<(int, int)>> antennae = []; HashSet<(int, int)> antinodes = []; for (int i = 0; i < width; i++) { for (int j = 0; j < height; j++) { if ('.' == data[j][i]) continue; antennae.TryAdd(data[j][i], []); foreach (var (oi, oj) in antennae[data[j][i]]) { int di = i - oi; int dj = j - oj; int ai = i + di; int aj = j + dj; if (ai >= 0 && aj >= 0 && ai < width && aj < height) { antinodes.Add((ai, aj)); } ai = oi - di; aj = oj - dj; if (ai >= 0 && aj >= 0 && ai < width && aj < height) { antinodes.Add((ai, aj)); } } antennae[data[j][i]].Add((i, j)); } } return antinodes.Count.ToString(); } public string SolveSecond() { Dictionary<char, List<(int, int)>> antennae = []; HashSet<(int, int)> antinodes = []; for (int i = 0; i < width; i++) { for (int j = 0; j < height; j++) { if ('.' == data[j][i]) continue; antennae.TryAdd(data[j][i], []); foreach (var (oi, oj) in antennae[data[j][i]]) { int di = i - oi; int dj = j - oj; for (int ai = i, aj = j; ai >= 0 && aj >= 0 && ai < width && aj < height; ai += di, aj +=dj) { antinodes.Add((ai, aj)); } for (int ai = oi, aj = oj; ai >= 0 && aj >= 0 && ai < width && aj < height; ai -= di, aj -=dj) { antinodes.Add((ai, aj)); } } antennae[data[j][i]].Add((i, j)); } } return antinodes.Count.ToString(); } }
C
Not hard but a little fiddly.
Code
#include "common.h" #define GZ 52 static char g[GZ][GZ]; #define ANTI_P1 1 #define ANTI_P2 2 static uint8_t anti[GZ][GZ]; static int w,h; int main(int argc, char **argv) { int p1=0,p2=0, x,y, x1,y1, ax,ay, i; char *lf; if (argc > 1) DISCARD(freopen(argv[1], "r", stdin)); for (h=0; h<GZ && fgets(g[h], GZ, stdin); h++) ; assert(feof(stdin)); lf = strchr(g[0], '\n'); assert(lf); w = lf - g[0]; /* * Find antenna pairs, then project backwards from the first, * forwards from the second. Don't like the repetition but it * makes for easy code. */ for (y=0; y<h; y++) for (x=0; x<w; x++) { if (!isalnum(g[y][x])) continue; for (y1=y; y1<h; y1++) for (x1=(y==y1?x+1:0); x1<w; x1++) { if (g[y][x] != g[y1][x1]) continue; for (i=0; ; i++) { if ((ax = x-(x1-x)*i) <0 || ax>w || (ay = y-(y1-y)*i) <0 || ay>h) break; anti[ay][ax] |= ANTI_P1 * i==1; anti[ay][ax] |= ANTI_P2; } for (i=0; ; i++) { if ((ax = x1+(x1-x)*i) <0 || ax>w || (ay = y1+(y1-y)*i) <0 || ay>h) break; anti[ay][ax] |= ANTI_P1 * i==1; anti[ay][ax] |= ANTI_P2; } } } for (y=0; y<h; y++) for (x=0; x<w; x++) { p1 += !!(anti[y][x] & ANTI_P1); p2 += !!(anti[y][x] & ANTI_P2); } printf("08: %d %d\n", p1, p2); return 0; }
Julia
I was surprised when my solution worked for part 2 since I thought you also had to include fractions of antenna distances, but apparently not.
Code
function readInput(inputFile::String)::Matrix{Char} f = open(inputFile,"r") lines::Vector{String} = readlines(f) close(f) cityMap = Matrix{Char}(undef,length(lines),length(lines[1])) for (i,l) in enumerate(lines) cityMap[i,:] = collect(l) end return cityMap end function getAntennaLocations(cityMap::Matrix{Char})::Dict antennaLocations = Dict{Char,Vector{Vector{Int}}}() for l=1 : size(cityMap)[1] for c=1 : size(cityMap)[2] cityMap[l,c]=='.' ? continue : nothing if !haskey(antennaLocations,cityMap[l,c]) antennaLocations[cityMap[l,c]] = [] end push!(antennaLocations[cityMap[l,c]],[l,c]) end end return antennaLocations end function countAntinodes(cityMap::Matrix{Char},antLoc::Dict{Char,Vector{Vector{Int}}},withHarmonics::Bool)::Int #antLoc: antenna locations lBounds = 1:size(cityMap)[1]; cBounds = 1:size(cityMap)[2] anodeLocs::Matrix{Bool} = zeros(size(cityMap)) for key in keys(antLoc) for i=1 : length(antLoc[key]) withHarmonics&&length(antLoc[key])>1 ? anodeLocs[antLoc[key][i][1],antLoc[key][i][2]]=1 : nothing #add antenna locations as antinodes #should also add fractions of antenna distances, but works without for j=i+1 : length(antLoc[key]) harmonic::Int = 1 while true n1l = antLoc[key][i][1]+harmonic*(antLoc[key][i][1]-antLoc[key][j][1]) n1c = antLoc[key][i][2]+harmonic*(antLoc[key][i][2]-antLoc[key][j][2]) n2l = antLoc[key][j][1]+harmonic*(antLoc[key][j][1]-antLoc[key][i][1]) n2c = antLoc[key][j][2]+harmonic*(antLoc[key][j][2]-antLoc[key][i][2]) if n1l in lBounds && n1c in cBounds anodeLocs[n1l,n1c] = 1 end if n2l in lBounds && n2c in cBounds anodeLocs[n2l,n2c] = 1 end withHarmonics ? nothing : break !(n1l in lBounds) && !(n1c in cBounds) && !(n2l in lBounds) && !(n2c in cBounds) ? break : harmonic+=1 end end end end return sum(anodeLocs) end @info "Part 1" println("antinode count $(countAntinodes(getAntennaLocations(readInput("day08Input"))),false)") @info "Part 2" println("antinode count $(countAntinodes(getAntennaLocations(readInput("day08Input"))),faltrue)")
Dart
This really does feel like a weekend break this year, maybe Eric and co have begun to realise that family time is more precious than work time :-)
import 'dart:math'; import 'package:more/more.dart'; solve(List<String> lines, int min, int max) { var map = ListMultimap<String, Point<int>>(); for (var r in lines.indices()) { for (var ci in lines[r].split('').indexed()) { if (ci.value != '.') map[ci.value].add(Point(ci.index, r)); } } var anti = <Point<int>>{}; for (var k in map.keys) { for (var p in map[k].combinations(2, repetitions: false)) { var diff = p.last - p.first; for (var m in min.to(max)) { anti.addAll([p.first - diff * m, p.last + diff * m]); } } } return anti.count((e) => e.x.between(0, lines.first.length - 1) && e.y.between(0, lines.length - 1)); } part1(List<String> lines) => solve(lines, 1, 2); part2(List<String> lines) => solve(lines, 0, 50);
maybe Eric and co have begun to realise that family time is more precious than work time
Last year the difficulty was fluctuating from 0 to 100 each day.
This year all problems so far are suspiciously easy. Maybe the second half of the month will be extra hard?Maybe we’ve been good all year :-)
J
J really doesn’t have hashes! Or anything like hashes! And it’s really annoying after a while!
What it does have is automatic internal optimization via hashing of the “index of” operation
m i. n
wherem
is a fixed list (the object being searched) andn
is the query, which can vary. But as soon as you updatem
the hash table is thrown away. And you still have to choose some kind of numeric key, or store a list of boxed pairs where the first coordinate is the key – effectively this is an old-style Lisp association list, but with extra steps because you have to use boxing to defeat J’s automatic array concatenation and reshaping. If you want non-cubical shapes (J calls these “ragged arrays”), or heterogeneous lists, you end up writingu &.>
a lot – this means “unbox, applyu
then rebox”. J arrays are required to be rectangular and homogeneous, but a boxed anything is a single atom just like a number is.It’s just a really bad choice of language if you want data structures other than essentially-cubical arrays. On the other hand, once you beat the list manipulation primitives into producing your 1970s Lisp data structure of choice, the rest of the program is as nice as it usually is.
data_file_name =: '8.data' grid =: ,. > cutopen fread data_file_name 'rsize csize' =: $ grid inbounds =: monad : '(*/ y >: 0 0) * (*/ y < rsize, csize)' antenna_types =: (#~ (~: & '.')) ~. , grid NB. list_antennas gives a list of boxed matrices of shape 2 n_k in cell k, where NB. n_k is the number of antennas of type k and the rows are coordinates of that type list_antennas =: monad define antenna_locs =. (# antenna_types) $ a: for_r. i. rsize do. for_c. i. csize do. cell =. y {~ <(r, c) if. '.' ~: cell do. at =. antenna_types i. cell antenna_locs =. ((<(r, c)) ,&.> at { antenna_locs) at} antenna_locs end. end. end. NB. _2 ]\ l reshapes l into length 2 rows without finding its length ahead of time (_2 & (]\))&.> antenna_locs ) NB. a1 pair_antinodes a2 gives the two antinodes from that pair pair_antinodes =: dyad : '(#~ inbounds"1) ((2 * x) - y) ,: (2 * y) - x' NB. if u is a symmetric dyad expecting rank 1 arguments, u on_pairs is a monad NB. expecting a list of rank 1 arguments, and yields the concatenation of x u y NB. where (x, y) is drawn from the (unordered) pairs of elements of the argument NB. see page_pairs in 5.ijs for a non-point-free version of pair enumeration on_pairs =: adverb define ; @: (< @: u/"2) @: ({~ (; @: (< @: (,~"0 i.)"0) @: i. @: #)) ) NB. antinodes antennas gives a list (may contain duplicates) of all the antinodes from NB. that set of antennas antinodes =: pair_antinodes on_pairs NB. on_antennas concatenates and uniquifies result lists from all antennas on_antennas =: adverb define ~. @: ; @: (u &.>) @: list_antennas ) result1 =: # antinodes on_antennas grid NB. a1 res_antinodes a2 gives the list of antinodes from that pair with resonance res_antinodes =: dyad define step =. (% +./) x - y NB. lazy: max_steps doesn't take location of x into account max_steps =. <. (rsize % 1 >. | 0 { step) <. (csize % 1 >. 1 { step) (#~ inbounds"1) x +"1 step *"1 0 i: max_steps ) result2 =: # res_antinodes on_pairs on_antennas grid
Raku
Solution
sub MAIN($input) { my $file = open $input; my @map = $file.slurp.lines>>.comb>>.List.List; my %freqs; for 0..^@map.elems -> $row { for 0..^@map[0].elems -> $col { if @map[$row; $col] ne "." { my $freq = @map[$row; $col]; %freqs{$freq} = [] if %freqs{$freq}:!exists; %freqs{$freq}.push(($row, $col)); } } } my %antinodes is SetHash; for %freqs.kv -> $freq, @locations { for (0..^@locations.elems) X (0..^@locations.elems) -> ($loc1, $loc2) { next if $loc1 == $loc2; my @base = @locations[$loc1].List; my @vector = @locations[$loc2].List Z- @base; my @antinode1 = @base Z+ @vector.map(* * 2); %antinodes{@antinode1.List.raku}++ if point-is-in-map(@map, @antinode1); my @antinode2 = @base Z+ @vector.map(* * -1); %antinodes{@antinode2.List.raku}++ if point-is-in-map(@map, @antinode2); } } my $part1-solution = %antinodes.elems; say "part 1: $part1-solution"; my %antinodes2 is SetHash; for %freqs.kv -> $freq, @locations { for (0..^@locations.elems) X (0..^@locations.elems) -> ($loc1, $loc2) { next if $loc1 == $loc2; my @base = @locations[$loc1].List; my @vector = @locations[$loc2].List Z- @base; # make integer unit-ish vector for 2..@vector[0] -> $divisor { if @vector[0] %% $divisor and @vector[1] %% $divisor { @vector[0] = @vector[0] div $divisor; @vector[1] = @vector[1] div $divisor; } } for 0..max(@map.elems, @map[0].elems) -> $length { my @antinode = @base Z+ @vector.map(* * $length); if point-is-in-map(@map, @antinode) { %antinodes2{@antinode.List.raku}++ } else { last } } for 1..max(@map.elems, @map[0].elems) -> $length { my @antinode = @base Z+ @vector.map(* * -$length); if point-is-in-map(@map, @antinode) { %antinodes2{@antinode.List.raku}++ } else { last } } } } my $part2-solution = %antinodes2.elems; say "part 2: $part2-solution"; } sub point-is-in-map(@map, @point) { return False if !(0 <= @point[0] < @map.elems); return False if !(0 <= @point[1] < @map[0].elems); return True; }
Rust
Pretty happy with my solution today. I took my time today as it was a bit of a slow day and did it in Rust instead of python. Having proper Vec2 types is very nice.
Tap for spoiler
use std::{collections::HashMap, error::Error, io::Read}; use glam::{IVec2, Vec2}; fn permutations_of_size_two(antennas: &[Vec2]) -> Vec<[&Vec2; 2]> { let mut permutations = vec![]; for (i, antenna) in antennas.iter().enumerate() { for j in 0..antennas.len() { if i == j { continue; } permutations.push([antenna, &antennas[j]]) } } permutations } fn main() -> Result<(), Box<dyn Error>> { let mut input = String::new(); std::io::stdin().read_to_string(&mut input)?; let height = input.lines().count() as i32; let width = input.lines().next().unwrap().len() as i32; let antenna_positions = input .lines() .enumerate() .flat_map(|(y, l)| l.chars().enumerate().map(move |(x, c)| (Vec2::new(x as f32, y as f32), c)) ) .filter(|(_v, c)| *c != '.') .fold(HashMap::new(), |mut acc: HashMap<char, Vec<_>> , current| { acc.entry(current.1).or_default().push(current.0); acc }); let mut antinodes = vec![]; for (_c, antennas) in antenna_positions { let perms = permutations_of_size_two(&antennas); for [first, second] in perms { let mut i = 1.; loop { let antinode = (first + (second-first) * i).round(); if (0..height).contains(&(antinode.x as i32)) && (0..width).contains(&(antinode.y as i32)) { antinodes.push(antinode); } else { break; } i += 1.; } } } let mut antinode_count = 0; let map = input .lines() .enumerate() .map(|(y, l)| l.chars().enumerate().map(|(x, c)| { if antinodes.contains(&Vec2::new(x as f32, y as f32)) { println!("({x},{y})"); antinode_count += 1; return '#'; } c }).collect::<String>() ) .collect::<Vec<_>>() .join("\n"); println!("{map}"); println!("{antinode_count}"); Ok(()) }
Rust
use std::collections::{HashMap, HashSet}; use crate::solver::DaySolver; use crate::grid::{Coordinate, Grid}; fn add_distance(coordinate: Coordinate, distance: (i64, i64)) -> Option<Coordinate> { coordinate.try_add(distance) } fn sub_distance(coordinate: Coordinate, distance: (i64, i64)) -> Option<Coordinate> { coordinate.try_sub(distance) } fn part2_possible_antinodes<F>( grid: &Grid<Option<char>>, coordinate: Coordinate, distance: (i64, i64), op: F, mut accumulator: Vec<Coordinate> ) -> Vec<Coordinate> where F: Fn(Coordinate, (i64, i64)) -> Option<Coordinate> { match op(coordinate, distance).filter(|c| grid.get(*c).is_some()) { None => accumulator, Some(next_coord) => { accumulator.push(next_coord); part2_possible_antinodes(grid, next_coord, distance, op, accumulator) } } } trait Pairable<T> { fn pairs(&self) -> Vec<(&T, &T)>; } impl<T> Pairable<T> for HashSet<T> { fn pairs(&self) -> Vec<(&T, &T)> { let v: Vec<&T> = self.iter().collect(); let mut p = vec![]; for i in 0..v.len() { let thing1 = v[i]; for thing2 in &v[i+1..] { p.push((thing1, *thing2)); } } p } } fn parse_input(input: String) -> (Grid<Option<char>>, HashMap<char, HashSet<Coordinate>>) { let g: Grid<Option<char>> = input.lines() .map(|line| line.chars() .map(|c| if c == '.' { None } else { Some(c) }).collect::<Vec<Option<char>>>() ) .collect::<Vec<Vec<Option<char>>>>() .into(); let mut freq_to_coords: HashMap<char, HashSet<Coordinate>> = HashMap::new(); for (coord, freq_opt) in g.iter() { match freq_opt { None => (), Some(freq) => { freq_to_coords.entry(*freq) .and_modify(|coords| { coords.insert(coord); }) .or_insert(HashSet::from([coord])); } } } (g, freq_to_coords) } pub struct Day08Solver; impl DaySolver for Day08Solver { fn part1(&self, input: String) -> usize { let (g, freq_to_coords) = parse_input(input); let mut antinodes: HashSet<Coordinate> = HashSet::new(); for (_, coords) in freq_to_coords { // println!("Freq = {}", freq); for (c1, c2) in coords.pairs() { let distance = c1.xy_distance_to(c2); let possible_antinodes: Vec<Coordinate> = [c1.try_sub(distance), c2.try_add(distance)].into_iter() .flat_map(|co| co.filter(|c| g.get(*c).is_some())) .collect(); // println!("Pair = ({},{}), antinodes = {:?}", c1, c2, possible_antinodes); for antinode in possible_antinodes { antinodes.insert(antinode); } } } antinodes.len() } fn part2(&self, input: String) -> usize { let (g, freq_to_coords) = parse_input(input); let mut antinodes: HashSet<Coordinate> = HashSet::new(); for (freq, coords) in freq_to_coords { println!("Freq = {}", freq); for (c1, c2) in coords.pairs() { let distance = c1.xy_distance_to(c2); let possible_antinodes: Vec<Coordinate> = [ part2_possible_antinodes(&g, *c1, distance, add_distance, vec![*c1]), part2_possible_antinodes(&g, *c1, distance, sub_distance, vec![*c1]), part2_possible_antinodes(&g, *c2, distance, add_distance, vec![*c2]), part2_possible_antinodes(&g, *c2, distance, sub_distance, vec![*c2]), ].into_iter().flatten().collect(); println!("Pair = ({},{}), antinodes = {:?}", c1, c2, possible_antinodes); for antinode in possible_antinodes { antinodes.insert(antinode); } } } antinodes.len() } }
https://gitlab.com/bricka/advent-of-code-2024-rust/-/blob/main/src/days/day08.rs?ref_type=heads
Uiua
Getting closer to an elegant solution, but still a way to go…
Grid ← ⊜∘⊸≠@\n "............\n........0...\n.....0......\n.......0....\n....0.......\n......A.....\n............\n............\n........A...\n.........A..\n............\n............" Pairs ← ∧(⊂⧅≠2⊚⌕)⊙¤⊸(◴▽⊸≠@.♭)Grid[] # get pairs of nodes in grid (both ways round). InGrid ← ▽≡/××<⧻Grid:≥0.. # (posns) Keeps those in range. AntiNodes ← ↯∞_2≡(+¤⊙(פ)⊃⊣/-):¤ # (range, pairs) Find antinodes by taking offset, mul by range, add to last node, check it's in grid. &p ⧻InGrid◴ AntiNodes ↘1⇡2 Pairs &p ⧻InGrid◴ AntiNodes ↘0⇡50 Pairs
python
solution
import aoc def setup(): lines = aoc.get_lines(8, stripped=True) ll = len(lines) fm = {f: [(x, y) for y, r in enumerate(lines) for x, z in enumerate(r) if z == f] for f in {z for r in lines for z in r if z != '.'}} return ll, fm def fa(fm, ll, rh=False): ans = set() for cd in fm.values(): l = len(cd) for i in range(l): x1, y1 = cd[i] for j in range(i + 1, l): x2, y2 = cd[j] dx, dy = x2 - x1, y2 - y1 if rh: for k in range(-ll, ll): x, y = x1 + k * dx, y1 + k * dy if 0 <= x < ll and 0 <= y < ll: ans.add((x, y)) else: x3, y3, x4, y4 = x1 - dx, y1 - dy, x2 + dx, y2 + dy if 0 <= x3 < ll and 0 <= y3 < ll: ans.add((x3, y3)) if 0 <= x4 < ll and 0 <= y4 < ll: ans.add((x4, y4)) return len(ans) def one(): ll, fm = setup() print(fa(fm, ll)) def two(): ll, fm = setup() print(fa(fm, ll, rh=True)) one() two()